#!/usr/bin/env python
# encoding: utf-8
"""
sender.py

Sending thread for the client. All messages are sent here and from here 

Created by Elliot Pennington 2008-15-11 
Modified by Gregory Sheaffer
"""


class Sender:
    
    """
    Messages should always be sent to the server from this object, which
    is instantiated in the b_client construction.
    """
    
    def __init__(self, sockfd, out_queue, out_event):
        self.sockfd = sockfd
        self.out_queue = out_queue
        self.out_event = out_event
        
        self.wait_event()
    
    def wait_event(self):
        while 1:
            self.out_event.wait()
            while not self.out_queue.empty():
                try:
                    o_data = self.out_queue.get(True, 1)
                    self.sockfd.sendall(o_data)
                    self.out_queue.task_done()
                except Queue.Empty:
                    break
            