#!/usr/bin/env python
# encoding: utf-8
"""
outserver.py

The outserver accepts connections from Befrienders for sending messages out.
See handler.py for how the requests are actually handled.

This is more of an INWARD FACING SERVER. 

Created by Elliot Pennington on 2008-11-23.
"""


from socket import *
import befriender_handler
import net_info

bufsz = 1024
mysock = None
myhandler = None

def Go(addr, handler):
    """
    Start the outserver. 
    Serve forever.
    """
    myhandler = handler
    mysock = socket(AF_INET, SOCK_STREAM)
    mysock.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1) 
    mysock.bind(('', addr))
    mysock.listen(net_info.backlog)
    while 1:
        try:
            print "Waiting for connection!"
            request, client_address = mysock.accept()
            print "Got request!"
        except socket.error:
            return
        try:
            process_request(request, client_address, myhandler)
        except:
            handle_error(request, client_address)
            close_request(request)
        
def process_request_thread(myhandler, request, client_address):
    """ Called from within the new thread. Runs the handler. """ 
    myhandler(request, client_address)
        
def process_request(request, client_address, myhandler):
    """ Spin off the new thread """
    import threading
    t = threading.Thread(target=process_request_thread,
                         args=(myhandler, request, client_address))
    t.start()
    return

def handle_error(request, client_address):
    print "process_request error"
    
def close_request(request):
    request.close()

#if __name__ == '__main__':
#Go(1465, SamariteenHandler)

    
    
# class outserverTests(unittest.TestCase):
#     def setUp(self):
#         pass
# 
# 
# if __name__ == '__main__':
#     unittest.main()